/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2026 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.velocitycore.tablist;

import com.velocitypowered.api.network.ProtocolVersion;
import com.velocitypowered.proxy.protocol.ProtocolUtils;
import com.velocitypowered.proxy.protocol.packet.UpdateTeamsPacket;
import com.velocitypowered.proxy.protocol.packet.chat.ComponentHolder;
import io.netty.buffer.ByteBuf;
import net.kyori.adventure.text.Component;

import java.util.List;

public class UpdateTeamsPacketImpl extends UpdateTeamsPacket {

    public UpdateTeamsPacketImpl(String name, Mode mode, Component displayName, Component prefix, Component suffix, NameTagVisibility nameTagVisibility, CollisionRule collisionRule, int color, byte friendlyFlags, List<String> players) {
        super(name, mode, displayName, prefix, suffix, nameTagVisibility, collisionRule, color, friendlyFlags, players);
    }

    @Override
    public void encode(ByteBuf byteBuf, ProtocolUtils.Direction direction, ProtocolVersion protocolVersion) {
        ProtocolUtils.writeString(byteBuf, name);
        byteBuf.writeByte(mode.ordinal());

        switch (mode) {
            case CREATE, UPDATE:
                new ComponentHolder(protocolVersion, displayName).write(byteBuf);
                if (protocolVersion.lessThan(ProtocolVersion.MINECRAFT_1_13)) {
                    new ComponentHolder(protocolVersion, prefix).write(byteBuf);
                    new ComponentHolder(protocolVersion, suffix).write(byteBuf);
                }

                byteBuf.writeByte(friendlyFlags);
                if (protocolVersion.noLessThan(ProtocolVersion.MINECRAFT_1_21_5)) {
                    ProtocolUtils.writeVarInt(byteBuf, nameTagVisibility.ordinal());
                    ProtocolUtils.writeVarInt(byteBuf, collisionRule.ordinal());
                } else {
                    ProtocolUtils.writeString(byteBuf, nameTagVisibility.getValue());
                    ProtocolUtils.writeString(byteBuf, collisionRule.getValue());
                }
                if (protocolVersion.greaterThan(ProtocolVersion.MINECRAFT_1_12_2)) {
                    ProtocolUtils.writeVarInt(byteBuf, color);
                    new ComponentHolder(protocolVersion, prefix).write(byteBuf);
                    new ComponentHolder(protocolVersion, suffix).write(byteBuf);
                } else {
                    byteBuf.writeByte((byte) color);
                }
                // Fallthrough since players are at the end of the packet!
            case ADD_PLAYER, REMOVE_PLAYER:
                ProtocolUtils.writeVarInt(byteBuf, players.size());
                for (String player : players) {
                    ProtocolUtils.writeString(byteBuf, player);
                }
                break;
            case REMOVE:
                break;
        }
    }
}
